#ifndef BUTTON_H
#define BUTTON_H

#include "guielement.h"

class AWindow;
class AGUIXFont;

class Button:public GUIElement {
public:
  Button(AGUIX *aguix);
  Button(AGUIX *aguix,int x,int y,int width,
         const char *text,int fg,int bg,int data);
  Button(AGUIX *aguix,int x,int y,int width,int height,
         const char *text,int fg,int bg,int data);
  Button(AGUIX *aguix,int x,int y,int width,
         const char *text_normal,const char *text_high,
         int fg_normal,int fg_high,
         int bg_normal,int bg_high,int data);
  virtual ~Button();
  char *getText(int);
  void setText(int,const char *);
  bool getDualState();
  void setDualState(bool);
  void setFG(int,int);
  int getFG(int);
  void setBG(int,int);
  int getBG(int);
  int getData();
  void setData(int);
  void setState(int);
  int getState();
  virtual void redraw();
  virtual void flush();
  bool isInside(int x,int y);
  virtual bool handleMessage(XEvent *E,Message *msg);
  bool getShowDual();
  void setShowDual(bool);
  int setFont(char*);
  virtual const char *getType();
  virtual bool isType(const char *type);
private:
  char *text[2];
  int fg[2];
  int bg[2];
  int lastbg;
  bool dual;
  int data;
  int state;
  int instate;
  bool showdual;
  AGUIXFont *font;
  static const char *type;
};

#endif
