#ifndef SOLIDBUTTON_H
#define SOLIDBUTTON_H

#include "guielement.h"

class AGUIX;
class AGUIXFont;

class SolidButton:public GUIElement {
public:
  SolidButton(AGUIX *aguix);
  SolidButton(AGUIX *aguix,int x,int y,int width,
         const char *text,int fg,int bg,bool state);
  SolidButton(AGUIX *aguix,int x,int y,int width,int height,
         const char *text,int fg,int bg,bool state);
  virtual ~SolidButton();
  char *getText();
  void setText(const char *);
  void setFG(int);
  int getFG();
  void setBG(int);
  int getBG();
  bool getState();
  void setState(bool);
  virtual void redraw();
  virtual void flush();
  virtual bool handleMessage(XEvent *E,Message *msg);
  int setFont(char*);
  virtual const char *getType();
  virtual bool isType(const char *type);
private:
  char *text;
  int fg;
  int bg;
  int lastbg;
  bool state;
  AGUIXFont *font;
  static const char *type;
};

#endif
