#ifndef DND_H
#define DND_H

#include <aguix/message.h>
#include "datei.h"

class Lister;
class ListerMode;
class Worker;

class DNDMsg
{
public:
  DNDMsg(Worker *worker);
  DNDMsg(Worker *worker,AGDNDSTART s,AGDNDEND e);
  FileEntry *getFE();
  const char *getDestDir();
  Lister *getDestLister();
  ListerMode *getDestMode();
  Lister *getSourceLister();
  ListerMode *getSourceMode();

  void setStart(AGDNDSTART*s);
  void setEnd(AGDNDEND*e);
  const AGDNDSTART *getStart();
  const AGDNDEND *getEnd();

protected:
  AGDNDSTART start;
  AGDNDEND end;
  
  Lister *sl,*el;
  ListerMode *slm,*elm;
  
  Worker *worker;
};

#endif

