#ifndef LISTER_H
#define LISTER_H

#include <X11/X.h>
#include <aguix/aguix.h>
#include <aguix/awindow.h>
#include <aguix/button.h>
#include <aguix/listview.h>
#include <aguix/listviewdnd.h>
#include "datei.h"
#include "dnd.h"

class Worker;
class AGUIX;
class ListerMode;

typedef enum {CYCLICFUNC_MODE_NORMAL,CYCLICFUNC_MODE_FIRSTNULLFT,CYCLICFUNC_MODE_RESTART}
  cyclicfunc_mode_t;

class Lister
{
public:
  Lister(Worker*);
  ~Lister();
  void messageHandler(AGMessage *msg);
  AGUIX *getAGUIX();
  AWindow *getAWindow();
  void setActiveMode(ListerMode*);
  void getGeometry(int*,int*,int*,int*);
  ListerMode *getActiveMode();
  void setFocus(bool);
  bool getFocus();
  void switch2Mode(int);
  void setName(const char*);
  void setStatebarText(const char*);
  void makeActive();
  int getSide();
  bool isActive();
  void configure();
  Worker *getWorker();
  void cyclicfunc(cyclicfunc_mode_t mode);
  int saveState(Datei *fh);
  int loadState(Datei *fh);
  const char *getNameOfMode(int);
  
  void reconfig();
  
  bool startdnd(DNDMsg *dm);
protected:
  Worker *parent;
  AGUIX *aguix;
  AWindow *win;
  Button *lvb;
  ListerMode *activemode;
  int activemodeid;
  ListerMode **modes;
  bool hasFocus;
  int x,y,w,h;
};

#endif

