#ifndef OWNOP_H
#define OWNOP_H

#include "wdefines.h"
#include "functionproto.h"
#include <aguix/awindow.h>
#include <aguix/text.h>
#include <aguix/solidbutton.h>
#include <aguix/button.h>
#include <aguix/cyclebutton.h>
#include <aguix/stringgadget.h>

class Worker;

class OwnOp:public FunctionProto
{
public:
  OwnOp(Worker*);
  virtual ~OwnOp();
  virtual OwnOp *duplicate();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual bool save(Datei*);
  virtual int load(Datei*);
  virtual const char *getDescription();
  virtual int configure();

  typedef enum {OWNOP_START_NORMAL=0,
                OWNOP_START_IN_TERMINAL,
                OWNOP_START_IN_TERMINAL_AND_WAIT4KEY,
                OWNOP_SHOW_OUTPUT} ownstart_t;
  void setWithApo(bool);
  void setSeparateEachEntry(bool);
  void setRecursive(bool);
  void setOwnStart(ownstart_t);
  void setComStr(const char*);
protected:
  static const char *name;
  // Infos to save
  bool withapo;
  bool separate_each_entry;
  bool recursive;

  ownstart_t ownstart;

  char *com_str;
  char *view_str;
  
  // temp variables
  Lister *startlister,*endlister;
  
  int normalmodeown();
  char *getFlag();
};

#endif
