#ifndef STARTPROGOP_H
#define STARTPROGOP_H

#include "wdefines.h"
#include "functionproto.h"
#include <aguix/awindow.h>
#include <aguix/text.h>
#include <aguix/solidbutton.h>
#include <aguix/button.h>
#include <aguix/cyclebutton.h>
#include <aguix/stringgadget.h>

class Worker;

class StartProgOp:public FunctionProto
{
public:
  StartProgOp(Worker*);
  virtual ~StartProgOp();
  virtual StartProgOp *duplicate();
  virtual bool isName(const char *);
  virtual const char *getName();
  virtual int run(ActionMessage*);
  virtual bool save(Datei*);
  virtual int load(Datei*);
  virtual const char *getDescription();
  virtual int configure();
  
  int doconfigure(int mode);

  typedef enum {STARTPROGOP_START_NORMAL=0,
                STARTPROGOP_START_IN_TERMINAL,
                STARTPROGOP_START_IN_TERMINAL_AND_WAIT4KEY,
                STARTPROGOP_SHOW_OUTPUT} startprogstart_t;
  void setStart(startprogstart_t);
  void setGlobal(bool);
  void setRequestFlags(bool);
protected:
  static const char *name;
  // Infos to save

  startprogstart_t startprogstart;

  char *view_str;
  bool global,requestflags;
  
  // temp variables
  Lister *startlister,*endlister;
  
  startprogstart_t tstartprogstart;
  char *tview_str;
  bool tglobal,trequestflags;
  
  int normalmodestartprog();
};

#endif
