#include "wdefines.h"
#include <aguix/util.h>
#include <aguix/lowlevelfunc.h>

bool fileExists(const char *name)
{
  struct stat stbuf;
  if(lstat(name,&stbuf)!=0) return false;
  return true;
}

int main(int argc,char **argv)
{
  char *tstr,*homestr,*filestr,*tstr2,*cstr;
  char buf[10],timebuf[sizeof(time_t)],lang[3];
#ifdef USE_MEM_SYSTEM
  _memsysteminit();
#endif
  bool copyconfig=false;
  
  printf("This is the worker_inst-program. It belongs to the worker filemanager.\n");
  printf("  This will help you to install an example configuration file in your language.\n");
  printf("  After this you can start worker even if there will be\n  an error while copying the example configuration!\n\n");
  
  homestr=getenv("HOME");
  if(homestr==NULL) {
    printf("There is no HOME-variable. Please set it to your home and retry.\n");
  } else {
    filestr=catstring(homestr,"/.worker/config");
    if(fileExists(filestr)==true) {
      printf("There is an existing config file for worker!\n");
      printf("Shall I copy an example configuration,\n");
      printf(" this existing configuration will be backuped!\n[n/y]:");
      fflush(stdout);
      fgets(buf,9,stdin);
      if((buf[0]=='y')||(buf[0]=='Y')) {
        tstr=NULL;
        do {
          if(tstr!=NULL) _freesafe(tstr);
          sprintf(timebuf,"-%ld",time(NULL));
          tstr=catstring(filestr,timebuf);
        } while(fileExists(tstr)==true);
        tstr2=(char*)_allocsafe(strlen("mv ")+strlen(filestr)+1+strlen(tstr)+1);
        sprintf(tstr2,"mv %s %s",filestr,tstr);
        system(tstr2);
        printf("Your old configuration has been renamed to %s!\n",tstr);
        _freesafe(tstr2);
        _freesafe(tstr);
        copyconfig=true;
      }
    } else copyconfig=true;
    if(copyconfig==true) {
      printf("Now choose your language (this can be changed later):\n");
      printf(" 1..english\n 2..deutsch\n 3..francais\n");
      fflush(stdout);
      fgets(buf,9,stdin);
      switch(buf[0]) {
        case '2':
          strcpy(lang,"de");
          break;
        case '3':
          strcpy(lang,"fr");
          break;
        default:
          strcpy(lang,"en");
          break;
      }
      tstr=catstring(homestr,"/.worker");
      if(fileExists(tstr)==false) {
        tstr2=(char*)_allocsafe(strlen("mkdir ")+strlen(tstr)+1);
        sprintf(tstr2,"mkdir %s",tstr);
        system(tstr2);
        _freesafe(tstr2);
      }
      _freesafe(tstr);
      tstr=catstring(homestr,"/.worker/catalogs");
      if(fileExists(tstr)==false) {
        tstr2=(char*)_allocsafe(strlen("mkdir ")+strlen(tstr)+1);
        sprintf(tstr2,"mkdir %s",tstr);
        system(tstr2);
        _freesafe(tstr2);
      }
      _freesafe(tstr);

      cstr=catstring(GLOBALDATADIR"/config-",lang);
      
      if(fileExists(cstr)==true) {
        tstr=(char*)_allocsafe(strlen("cp ")+strlen(cstr)+1+strlen(filestr)+1);
        sprintf(tstr,"cp %s %s",cstr,filestr);
        system(tstr);
        _freesafe(tstr);
        if(fileExists(filestr)==false) {
          printf("The configfile couldn't be copyied!\n");
        } else {
          printf("Installation finished.\n");
        }
      } else {
        printf("There is no example configuration at %s!\nPerhaps worker s not completely installed!\n\n",cstr);
      }
      
      _freesafe(cstr);
    }
    _freesafe(filestr);
  }
#ifdef USE_MEM_SYSTEM
  _memsystemcheck();
#endif
  return 0;
}

