#include "wdefines.h"
#include <aguix/util.h>
#include <aguix/lowlevelfunc.h>

#define XLISTR "xli -quiet -border gray -clip %d,%d,%d,%d -zoom %d -windowid 0x%s \"%s\""

bool fileExists(const char *name)
{
  struct stat stbuf;
  if(lstat(name,&stbuf)!=0) return false;
  return true;
}

char *createTMPName()
{
  char *returnstr,buffer[128];
  int rannr;
  
  for(;;) {
    rannr=rand();
    sprintf(buffer,"%d",rannr);
    returnstr=(char*)_allocsafe(strlen("/tmp/worker")+strlen(buffer)+1);
    sprintf(returnstr,"/tmp/worker%s",buffer);
    if(fileExists(returnstr)==false) break;
    _freesafe(returnstr);
  }
  return returnstr;
}

int main(int argc,char **argv)
{
  char *tstr,*tmp;
  int ch,wi,he,mode;
  int aw,ah,ax,ay,xzf,yzf,zf;
  int tx,ty,tw,th;
  
  FILE *fp;
  
#ifdef USE_MEM_SYSTEM
  _memsysteminit();
#endif

  srand(time(NULL));  
  if(argc<7) {
    printf("This is the xliwrapper_worker program. It belongs to the worker filemanager.\n");
    printf("  This is not a standalone program but will normally called from\n  worker to display pics in it.\n");
    printf("  The arguments are:\n");
    printf("  1.x-coord.\n  2.y-coord.\n  3.width of the area\n  4.height of the area\n  5.hex-number of the window\n");
    printf("  6.the filename to show\n\n");
  } else {
    tmp=createTMPName();
    tstr=(char*)_allocsafe(strlen("xli -identify \"\" > 2>/dev/null")+strlen(argv[6])+strlen(tmp)+1+128);
    sprintf(tstr,"xli -identify  \"%s\" >%s 2>/dev/null",argv[6],tmp);
    system(tstr);
    _freesafe(tstr);

    fp=fopen(tmp,"r");
    if(fp!=NULL) {
      wi=he=0;
      mode=0;
      for(;;) {
        ch=getc(fp);
        if(ch==EOF) break;
        switch(mode) {
          case 1://i
            if(ch=='s') mode=2;
            else if(ch!='i') mode=0;
            break;
          case 2://s
            if(ch==' ') mode=3;
            else if(ch=='i') mode=1;
            else mode=0;
            break;
          case 3://<space>
            if(ch=='a') mode=4;
            else if(ch=='i') mode=1;
            else mode=0;
            break;
          case 4://a
            if(ch==' ') mode=5;
            else if(ch=='i') mode=1;
            else mode=0;
            break;
          case 5:// now follows the widthxheight
            if(isdigit(ch)) {
              wi*=10;
              wi+=ch-'0';
            } else if(ch=='x') mode=6;
            else mode=7;
            break;
          case 6:
            if(isdigit(ch)) {
              he*=10;
              he+=ch-'0';
            } else mode=7;
            break;
          case 7:
            break;
          default:
            if(ch=='i') mode=1;
            break;
        }
        if(mode==7) break;
      }
      fclose(fp);

      if((wi>0)&&(he>0)) {
        // valid width and height
        ax=atoi(argv[1]);
        ay=atoi(argv[2]);
        aw=atoi(argv[3]);
        ah=atoi(argv[4]);
        
        xzf=aw*100/wi;
        yzf=ah*100/he;
        zf=(xzf>yzf)?yzf:xzf;
        if(zf<1) zf=1;
        
        tx=ax*100/zf;
        ty=ay*100/zf;
        tw=aw*100/zf;
        tw++;
        th=ah*100/zf;
        th++;
        
        tstr=(char*)_allocsafe(strlen(XLISTR)+5*sizeof(int)+strlen(argv[5])+strlen(argv[6])+1+128);
        sprintf(tstr,XLISTR,tx,ty,tw,th,zf,argv[5],argv[6]);
        system(tstr);
        _freesafe(tstr);
      }
    }
    
    remove(tmp);
    _freesafe(tmp);
  }  
#ifdef USE_MEM_SYSTEM
  _memsystemcheck();
#endif
  return 0;
}

